package arms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListOnCallSchedules invokes the arms.ListOnCallSchedules API synchronously
func (client *Client) ListOnCallSchedules(request *ListOnCallSchedulesRequest) (response *ListOnCallSchedulesResponse, err error) {
	response = CreateListOnCallSchedulesResponse()
	err = client.DoAction(request, response)
	return
}

// ListOnCallSchedulesWithChan invokes the arms.ListOnCallSchedules API asynchronously
func (client *Client) ListOnCallSchedulesWithChan(request *ListOnCallSchedulesRequest) (<-chan *ListOnCallSchedulesResponse, <-chan error) {
	responseChan := make(chan *ListOnCallSchedulesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListOnCallSchedules(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListOnCallSchedulesWithCallback invokes the arms.ListOnCallSchedules API asynchronously
func (client *Client) ListOnCallSchedulesWithCallback(request *ListOnCallSchedulesRequest, callback func(response *ListOnCallSchedulesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListOnCallSchedulesResponse
		var err error
		defer close(result)
		response, err = client.ListOnCallSchedules(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListOnCallSchedulesRequest is the request struct for api ListOnCallSchedules
type ListOnCallSchedulesRequest struct {
	*requests.RpcRequest
	Size requests.Integer `position:"Query" name:"Size"`
	Name string           `position:"Query" name:"Name"`
	Page requests.Integer `position:"Query" name:"Page"`
}

// ListOnCallSchedulesResponse is the response struct for api ListOnCallSchedules
type ListOnCallSchedulesResponse struct {
	*responses.BaseResponse
	RequestId string   `json:"RequestId" xml:"RequestId"`
	PageBean  PageBean `json:"PageBean" xml:"PageBean"`
}

// CreateListOnCallSchedulesRequest creates a request to invoke ListOnCallSchedules API
func CreateListOnCallSchedulesRequest() (request *ListOnCallSchedulesRequest) {
	request = &ListOnCallSchedulesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS", "2019-08-08", "ListOnCallSchedules", "", "")
	request.Method = requests.GET
	return
}

// CreateListOnCallSchedulesResponse creates a response to parse from ListOnCallSchedules response
func CreateListOnCallSchedulesResponse() (response *ListOnCallSchedulesResponse) {
	response = &ListOnCallSchedulesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
